<template>
  <no-ssr>
<div>
  <h1>Wallet Demo!</h1>
  <h2>Mnemonic:</h2>
  <el-input type="textarea" v-model="mnemonic" />
  <el-alert v-if="error" :title="error" type="error" />
  
  <el-button @click="mnemonic = 'upper high until jaguar under fish flash lift hazard penalty text trophy'">upper high until...</el-button>
  <el-button @click="mnemonic = 'trim witness apart poet camp culture glare capital ranch inspire tent arch'">(busted) trim witness apart...</el-button>
  <el-button @click="mnemonic = 'drastic liquid replace property pull girl spot funny immune mandate hold vague'">drastic liquid replace...</el-button>
  
  <el-button type="danger" @click="randomizeMnemonic">Randomize</el-button>
  
  <el-alert v-if="wallet && wallet.error" :title="wallet.error" type="error" />
  
  <el-tabs type="border-card" v-if="this.wallet">
    <el-tab-pane v-for="currency,name in this.wallet.currencies" :label="name" v-loading="!wallet || !currency.initialized">
      <div>Receive address: {{ currency.receiveAddress }}</div>
      <div>Balance: {{ currency.balance && currency.balance.toString() }}</div>
      <transaction-table-row v-for="tx in currency.transactions" :value="tx" :currency="currency" />
      
      <send-transaction :currency="currency" />
    </el-tab-pane>
  </el-tabs>
</div>
</no-ssr>
</template>
<style lang="scss" scoped>

</style>
<script>

import Wallet from '~/lib/wallet';
import Mnemonic from 'bitcore-mnemonic';

import { get } from '~/lib/utils';
import TransactionTableRow from '~/components/TransactionTableRow';
import SendTransaction from '~/components/SendTransaction';

const walletOptions = { api: '/api/' };

export default {
  data() {
    return {
      error: null,
      wallet: null,
      amount: 0,
      fee: 0,
    }
  },
  components: { TransactionTableRow, SendTransaction },
  mounted() {
    let saved = localStorage.getItem('saved-mnemonic');
    try {
      new Mnemonic(saved);
    } catch(x) {
      this.error = x;
      saved = null;
    }
    
    this.wallet = Wallet(saved,walletOptions);
    if(!saved) {
      localStorage.setItem('saved-mnemonic',this.wallet.mnemonic);
    }
  },
  computed: {
    bitcoinReceiveAddress() {
      return get(this.wallet,'currencies.btc.receiveAddress');
    },
    bitcoinTransactions() {
      return get(this.wallet,'currencies.btc.transactions');
    },
    bitcoinCurrencyId() {
      return get(this.wallet,'currencies.btc.currencyId');
    },
    mnemonic: {
      set(mnemonic) {
        this.error = null;
        
        try {
          const m = new Mnemonic(mnemonic);
        } catch(x) {
          this.error = x;
        }
        
        if(this.wallet && this.wallet.mnemonic != mnemonic) {
          this.wallet = null;
          
          setTimeout(() => {          
            this.wallet = Wallet(mnemonic, walletOptions);
            localStorage.setItem('saved-mnemonic',this.wallet.mnemonic);
          },50);
        }
      },
      get(mnemonic) {
        return this.wallet && this.wallet.mnemonic;
      }
    }
  },
  methods: {
    randomizeMnemonic() {
      this.mnemonic = (new Mnemonic(Mnemonic.Words.ENGLISH)).toString();
    }
  }
}

</script>

